#######################################################
## This R script reads in the different precipitation data
## (IMIS measurements, ANTEZ regressions and modeld snowpack output
## out of this 3 possibilitys, a complete precipitation data set is generatet, 
##using the functions in file functions.R and written out
#### filename= Decicion.R          ###################
######################################################

#############read in ANETZ Rrecipitation data##########################################
AN<- list.files("XXX")	#Give location of ANETZ regression

setwd("XX")	#set to location of ANETz regression DAta
list_AN<- lapply(AN, function(x) {read.table(x, header=FALSE, skip = 19, na.strings = "NA")})
names(list_AN)<- sub("\\.smet", "", AN)
list_AN<-lapply(list_AN, function(x) {names(x)<- c("date", "TA","RH","TSG","TSS","HS","VW" , "DW","OSWR", "ILWR", "PSUM_A");x} )
list_AN<- lapply(list_AN, function(x){x$date <- strptime(x$date,format="%Y-%m-%dT%H:%M:%S");x})
list_AN<- lapply(list_AN, function(x){x[x==-999]=NA;x}) #replaces missing values with NA
list_AN<- lapply(list_AN, function(x){x$PSUM_A[x$PSUM_A>50]=NA;x}) 
list_AN<- lapply(list_AN, function(x){x<- x[,c(1:9,11)]})


#############read in IMIS precipitation Data ##########################################

IM<- list.files("XX")	#Give location of IMIS Data Sets
IM
IM<- IM[c(1,3:5,7:9,12,13,15)] #reorder
setwd("XXX")	#Set to  location of IMIS Data Sets
list_IM<- lapply(IM, function(x) {read.table(x, header=FALSE, skip = 19, na.strings = "NA")})
names(list_IM)<- sub("\\.smet", "", IM)
i1<- c(1,2,9) #stations without prec. measurements
i2<- c(3,4,5,6,7,8,10)
list_IM[i1]<-lapply(list_IM[i1], function(x) {names(x)<-c("date", "TA","RH","TSG","TSS","HS","VW" , "DW","OSWR", "ILWR" );x}) 
list_IM[i2]<-lapply(list_IM[i2], function(x) {names(x)<- c("date", "TA","RH","TSG","TSS","HS","VW" , "DW","OSWR", "ILWR", "PSUM_I");x} )
list_IM<- lapply(list_IM, function(x){x$date <- strptime(x$date,format="%Y-%m-%dT%H:%M:%S");x})
list_IM<- lapply(list_IM, function(x){x[x==-999]=NA;x}) 
list_IM<- lapply(list_IM, function(x){x$PSUM_I[x$PSUM_I>50]=NA;x}) 
list_IM[i1]<- lapply(list_IM[i1], function(x){x$PSUM_I<- NA;x}) #column with NA because does stations don't have IMIS prec. measrumets
list_IM<- lapply(list_IM, function(x){x<- x[,c(1,11)]})
setwd("/home/bender/R/Data_Set/Comp_RM")

#######   read in SNowpack modeld files
snop<- list.files("XXX", pattern="\\.dat")	#Give location of Snowpack Data Sets
snop
setwd("XX")	#Give location of Snowpack Data Sets
list_sn<- lapply(snop, function(x){read.table(x, header=FALSE, skip=2)})
list_sn<- lapply(list_sn, function(x){names(x)<- c("date", "PS_SP");x})
list_sn<- lapply(list_sn, function(x){x$date<- strptime(x$date, format="%Y-%m-%dT%H:%M");x})
names(list_sn)<- snop

setwd("/home/bender/R/Data_Set/Data_set_final")


##merge the 3 fiels into one
list_dc<- list_AN
list_dc<- lapply(list_dc, function(x){x<- x[,c(1:3,5:7,9)]})
list_dc<- lapply(list_dc, function(x){x$date<- strptime(x$date, format="%Y-%m-%dT%H:%M");x})

i<-1
while(i<=length(list)){
  list_dc[[i]]<- merge(list_dc[[i]], list_sn[[i]], by="date", sort=FALSE) 
  list_dc[[i]]<- merge(list_dc[[i]], list_IM[[i]], by="date", sort=FALSE) 
  list_dc[[i]]<- merge(list_dc[[i]], list_AN[[i]], by="date", sort=FALSE) 
  i<-i+1
}

list_dc<- lapply(list_dc, function(x){x$PS<- NA;x})
list_dc<- lapply(list_dc, function(x){x$de<- de(x$HS,3);x})

##############applay decision function############################3
i<-1
while(i<=length(i2)){
#while(i<=5){
  m<-1
  t<- list_dc[[i2[i]]]
  #while(m<=100){
 while(m<=nrow(t)){
    list_dc[[i2[i]]][m,"PS"]<- DC1(t[m,"RH"], t[m,"HS"], t[m,"TA"],t[m,"TSS"], t[m,"PS_SP"], t[m,"PSUM_A"],t[m,"PSUM_I"] ,t[m,"de"], 0)
       m<-m+1
  }
  i<-i+1  
}
t<- list_dc[[5]]

i<-1
while(i<=length(i1)){
  #while(i<=5){
  m<-1
  t<- list_dc[[i1[i]]]
  #while(m<=100){
  while(m<=nrow(t)){
    list_dc[[i1[i]]][m,"PS"]<- DC3(t[m,"RH"], t[m,"HS"], t[m,"TA"],t[m,"TSS"], t[m,"PS_SP"], t[m,"PSUM_A"] ,t[m,"de"], 0)
    m<-m+1
  }
  i<-i+1  
}


##################################################################################
#####write out precipitation data set and change time to 15min time steps#########


#######********************change timesteps**************************

i<-1
while(i<=length(list_dc)){
  t1<- list_dc[[i]]
  t1$PS<- t1$PS/4
  
  t2<- t1
  t2$date<- t2$date+15*60
  
  t3<- t1
  t3$date<- t3$date+30*60
  
  t4<- t1
  t4$date<- t4$date+45*60
  
  
  t<-rbind(t1, t2, t3, t4)
  t<- t[order(t$date),]
  setwd("/home/bender/R/Data_Set/Data_set_final/data")
  t[,1]<- as.character(t[,1])
  t$date<- t$date<- gsub("\\ ", "T", t$date)
  write.table(t[,c(1:7,11)],file = files[i], na="NA", row.names = FALSE, quote=FALSE)
  i<-i+1
}







